module SetTest where

--import SetWithList
import SetWithTree
import Test.HUnit

-- Lokale Mengen
fullList  = insert 1 (insert 2 (insert 3 empty))
fullList2 = insert 4 (insert 5 (insert 6 empty))


-- Testcases, abgeleitet aus den Mengenaxiomen

-- insert x (insert x xs) = insert x xs
test1 = TestCase (assertEqual "Axiom1" (insert 1 empty) (insert 1 (insert 1 empty)))

--insert x (insert y xs) = insert y (insert x xs)
test2 = TestCase (assertEqual "Axiom2" (insert 1 (insert 2 empty)) (insert 2 (insert 1 empty)))

--isEmpty empty          = True
test3 = TestCase (assertEqual "Axiom3" (True) (isEmpty empty))

--isEmtpy (insert x xs)  = False
test4 = TestCase (assertEqual "Axiom4" (False) (isEmpty(insert 1 empty)))

--member empty y         = False
test5 = TestCase (assertEqual "Axiom5" (False) (member empty 1))

--member (insert x xs) y = (x == y) || member xs y
test6a = TestCase (assertEqual "Axiom6a" (member fullList 1) (True))
test6b = TestCase (assertEqual "Axiom6b" (member fullList 4) (False)) 

--delete x empty         = empty
test7 = TestCase (assertEqual "Axiom7" (empty) (delete 1 empty))

--delete x (insert y xs) = if x == y then delete x xs else insert y (delete x xs)
test8a = TestCase (assertEqual "Axiom8a" (delete 1 (insert 1 empty)) (empty))
test8b = TestCase (assertEqual "Axiom8b" (delete 2 (insert 1 empty)) (insert 1 empty))
test8c = TestCase (assertEqual "Axiom8c" (delete 1 (insert 1 (insert 1 empty))) (empty))
test8d = TestCase (assertEqual "Axiom8d" (delete 5 (delete 2 (delete 4 (insert 5 (insert 2 (insert 4 empty)))))) (empty))

--union xs empty         = xs
test9 = TestCase (assertEqual "Axiom9" (union fullList empty) (fullList))

--union xs (insert y ys) = insert y (union xs ys)
test10 = TestCase (assertEqual "Axiom10" (union fullList (insert 7 fullList2)) (insert 7 (union fullList fullList2)))

--meet xs empty          = emtpy
test11 = TestCase (assertEqual "Axiom11" (meet fullList empty) (empty))

--meet xs (insert y ys)  = if member xs y then insert y (meet xs ys) else meet xs ys
test12a = TestCase (assertEqual "Axiom12a" (meet fullList fullList2) (empty))
test12b = TestCase (assertEqual "Axiom12b" (meet fullList (union fullList fullList2)) (fullList))

--minus xs empty         = xs
test13 = TestCase (assertEqual "Axiom13" (minus fullList empty) (fullList))
--test13 = TestCase (assertEqual "Axiom13" (minus fullList empty) (empty))

--minus xs (insert y ys) = minus(delete y xs) ys
test14a = TestCase (assertEqual "Axiom14a" (minus fullList fullList2) (fullList))
test14b = TestCase (assertEqual "Axiom14b" (minus fullList (insert 1 fullList2)) (minus (delete 1 fullList) fullList2))

tests = TestList [TestLabel "test1"   test1, 
                  TestLabel "test2"   test2,
                  TestLabel "test3"   test3,
                  TestLabel "test4"   test4,
                  TestLabel "test5"   test5,
                  TestLabel "test6a"  test6a,
                  TestLabel "test6b"  test6b,
                  TestLabel "test7"   test7,
                  TestLabel "test8a"  test8a,
                  TestLabel "test8b"  test8b,
                  TestLabel "test8c"  test8c,
                  TestLabel "test8d"  test8d,
                  TestLabel "test9"   test9,
                  TestLabel "test10"  test10,
                  TestLabel "test11"  test11,
                  TestLabel "test12a" test12a,
                  TestLabel "test12b" test12b,
                  TestLabel "test13"  test13,
                  TestLabel "test14a"  test14a,
                  TestLabel "test14b"  test14b]

runTests = runTestTT tests
