module SetWithList (Set, empty, isEmpty, member, insert, delete, union, meet, minus) where

newtype Set a = MkL [a] deriving (Show)

-- Definition der Gleichheit von Mengen
instance Ord a => Eq (Set a)
  where
  (MkL xs) == (MkL ys) = (nonduplicated (qsort xs)) == (nonduplicated (qsort ys))

nonduplicated :: (Eq a) => [a] -> [a]
nonduplicated []  = []
nonduplicated [a] = [a]
nonduplicated (x1:x2:xs) = if (x1 == x2) then nonduplicated (x1:xs) else x1 : nonduplicated (x2:xs)

qsort    :: Ord a => [a] -> [a]
qsort []     = []
qsort (x:xs) = qsort [y | y <- xs, y < x] ++ [x] ++ qsort [y | y <- xs, y >= x]


-- Methoden

empty    :: Set a
empty = MkL []

isEmpty  :: Set a -> Bool
isEmpty (MkL xs) = null xs

member   :: (Eq a) => Set a -> a -> Bool
member (MkL xs) x = some (== x) xs

insert   :: (Eq a) => a -> Set a -> Set a
--insert x (MkL xs) = MkL (x : xs)
insert x (MkL xs) = MkL (x : filter (/= x) xs)


delete   :: (Eq a) => a -> Set a -> Set a
delete x (MkL xs) = MkL (filter (/= x) xs)

union    :: (Eq a) => Set a -> Set a -> Set a
--union (MkL xs) (MkL ys) = xs ++ ys
union (MkL xs) (MkL ys) = MkL (xs ++ filter (not . member (MkL xs)) ys)

meet     :: (Eq a) => Set a -> Set a -> Set a
meet (MkL xs) (MkL []) = empty
meet (MkL xs) (MkL(y:ys)) = if member (MkL xs) y then insert y (meet (MkL xs) (MkL ys)) else meet (MkL xs) (MkL ys)

minus    :: (Eq a) => Set a -> Set a -> Set a
minus (MkL xs) (MkL ys) = MkL (filter (not . member (MkL ys)) xs)

some :: (a -> Bool) -> [a] -> Bool
some p = or . map p

